<template>
  <div class="auth">
    <div v-if="!toVerifyEmailAccount && signIn">
      <div class="text-lg text-white opacity-75">Авторизация</div>
      <div>
        <label :class="{'error': signInError === 'email'}">
          <span>Email</span>
          <span v-if="signInError === 'email'" class="sign-in-error-message">{{signInErrorMessage}}</span>
          <input autofocus v-model="form.email" @keyup.enter="login" class="h-8" type="text">
        </label>
        <label :class="{'error': signInError === 'pass'}">
          <span>Пароль</span>
          <span v-if="signInError === 'pass'" class="sign-in-error-message">{{signInErrorMessage}}</span>
          <input v-model="form.pass" @keyup.enter="login" class="h-8" type="text">
        </label>
      </div>
      <div class="button mt-6 float-right" @click="login">Войти <loads-spinner v-if="loading" small/></div>
    </div>
    <div v-if="!toVerifyEmailAccount && sign">
      <div class="text-lg text-white opacity-75">Регистрация</div>
      <div>
        <label :class="{'error': signInError === 'email'}">
          <span>Email</span>
          <span v-if="signInError === 'email'" class="sign-in-error-message">{{signInErrorMessage}}</span>
          <input autofocus v-model="form.email" class="h-8" type="text">
        </label>
        <label :class="{'error': signInError === 'pass'}">
          <span>Пароль</span>
          <span v-if="signInError === 'pass'" class="sign-in-error-message">{{signInErrorMessage}}</span>
          <input v-model="form.pass" class="h-8" type="text">
        </label>
        <label :class="{'error': signInError === 'confirmPass'}">
          <span>Повторно пароль</span>
          <span v-if="signInError === 'confirmPass'" class="sign-in-error-message">{{signInErrorMessage}}</span>
          <input v-model="form.confirmPass" class="h-8" type="text">
        </label>
      </div>
      <div class="button mt-6 float-right" @click="signUp">Продолжить <loads-spinner v-if="loading" small/></div>
    </div>
    <div v-if="toVerifyEmailAccount">
      <p class="text-4xl text-white my-6 opacity-85">Почти готово!</p>
      <p class="text-xl text-white mb-6 opacity-85">Мы отправили на вашу почту письмо с подтвержением вашего аккаунта</p>
    </div>
  </div>
</template>

<script>
import {reactive, ref, watch} from "vue";
import {supabase} from "../supabase";
import LoadsSpinner from "./Loads-spinner.vue";

export default {
  name: "Auth",
  components: {LoadsSpinner},
  props: {
    sign: Boolean,
    signIn: Boolean
  },
  setup() {
    const loading = ref(false)
    const toVerifyEmailAccount = ref(false)
    // USER SIGNUP
    const form = reactive({
      email: null,
      pass: null,
      confirmPass: null,
    })
    const signInError = ref(null)
    const signInErrorMessage = ref('')
    async function signUp() {
      if (form.pass !== form.confirmPass) {
        signInError.value = 'confirmPass'
        signInErrorMessage.value = 'Пароли не совпадают'
      }
      else {
        try {
          loading.value = true
          let { user, error } = await supabase.auth.signUp({
            email: form.email,
            password: form.pass
          })
          if (error) {
            console.log(error)
            if (error.message === 'Password should be at least 6 characters') {
              signInError.value = 'pass'
              signInErrorMessage.value = 'Не менее 6 символов'
            } else if (error.message === 'Unable to validate email address: invalid format') {
              signInError.value = 'email'
              signInErrorMessage.value = 'Проверьте правильность Email'
            }
            throw error
          }
          if (user.id) {
            toVerifyEmailAccount.value = true
            setTimeout(() => {
              isModal.value = false
              toVerifyEmailAccount.value = false
            }, 10000)
          }
        } catch (error) {
          // alert('Ошибка, попробуйте позже, или свяжитесь с нами')
          console.log(error)
        } finally {
          loading.value = false
        }
      }
    }

    // LOGIN
    async function login() {
      if (!form.email) {
        signInError.value = 'email'
        signInErrorMessage.value = 'Введите почту'
      } else if (!form.pass) {
        signInError.value = 'pass'
        signInErrorMessage.value = 'Введите пароль'
      }
      else {
        try {
          loading.value = true
          let { user, error } = await supabase.auth.signIn({
            email: form.email,
            password: form.pass
          })
          if (error) {
            console.log(error)
            if (error.message === 'Invalid login credentials') {
              signInError.value = 'email'
              signInErrorMessage.value = 'Почта или пароль не верны'
            }
            throw error
          }
          if (user.id) {
            isModalLogin.value = false
          }
        } catch (error) {
          // alert('Ошибка, попробуйте позже, или свяжитесь с нами')
          console.log(error)
        } finally {
          loading.value = false
        }
      }
    }

    watch(form, () => {
      signInError.value = null
      signInErrorMessage.value = ''
    })
    return {
      form,
      signInError,
      signInErrorMessage,
      toVerifyEmailAccount,
      loading,
      signUp,
      login,
    }
  }
}
</script>

<style scoped>

</style>
